#!/bin/bash

## Setup Resonite Config
echo  "Setting up Resonite Config"

# if CONFIG_FILE is not set, use default config path
if  [ ! -f $CONFIG_FILE ]; then
    echo "No Resonite Config found, copying from template"
    cp /mnt/defaults/resonite.json $CONFIG_FILE
fi

CONFIG_DATA=$(grep -v " null," "$CONFIG_FILE")
if [ ! -n "$CONFIG_DATA" ]; then
    echo "Config file is empty, copying from template"
    cp /mnt/defaults/resonite.json $CONFIG_FILE
    CONFIG_DATA=$(grep -v " null," "$CONFIG_FILE")
fi

## Setup Modloader Configs
if [ "$RESONITE_MOD_LOADER" == "true" ]; then
    echo  "Setting up Modloader Configs" 
    DEFAULT_RESONITE_ARGS=$(echo "$DEFAULT_RESONITE_ARGS -LoadAssembly /data/resonite/Headless/Libraries/ResoniteModLoader.dll")
else
    echo  "Modloader is disabled"
fi